<!--免拼优化 created By 1173944134@qq.com-->
<template>
    <!--toast-->
    <div class="yidialog-con yid-toast-con" id="toastCon">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-con-body flex-row">
                <!--消息-->
                <div class="msg"></div>
            </div>
        </div>
    </div>
    <!--按钮-->
    <div class="flex-row pay-btn-con" id="payBtnCon">
        <div class="flex-row home">返回</div>
        <div class="flex-row ljgm">立即购买</div>
    </div>
    <!--首页弹窗-->
    <div class="yidialog-con home_dia" id="homeMyDia">
        <div class="yid-back"></div>
        <div class="yid-con flex-row yid-con-col">
            <div class="yid-con-body flex-row">
                <div class="kj-djs"></div>
                <div class="btn-baom-con">
                    <img src="" class="btn-baom heart-beat"/>
                </div>
            </div>
            <div class="yid-cls-con">
                <img src="" class="yid-cls"/>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: 'nospell',
        data: {
            updateTag: '/dengta/user/course/ext/updateTag.json?courseId={courseId}&tagIndex=1&tagValue=', // 更新是否置顶接口
            SECTION_LIST_DESC: 'SECTION_LIST_DESC', // 课程目录页显示过
            moreCourseInit: '/dengta/act/dual12/mainvenue/queryEntry.json', // 首页
            courseListInit: '/dengta/common/act/10016/courseList/init.json', // 课堂
            addLiveCourseUser: '/dengta/common/act/10016/addLiveCourseUser.json', // 海报
            courseImg: resourcePath + '/imgs/groupPurchase/newCourseImg/',
            imgPath: resourcePath + '/imgs/groupPurchase/act/double_12/',
            groupPurPath: resourcePath + '/imgs/groupPurchase/', // 图片地址
            pvuv: ApiHelper.SERVER + '/dengta/common/act/10029/addPvuv.json', // pvuv微信通用接口
            cDetailToHomePvuv: ApiHelper.SERVER + '/dengta/pvuv/btn/add.json' // 课程详情页点击回首页
        },
        exposeIdxs: [0, 1, 2, 3],
        tabBarH: 0, // 底部tabBar高度
        exposed: {},
        // pvuvkey
        pvuvKey: {
            expose: 'dt_1212_dual12_bogo_give_coupon_id_{couponId}_exposure', // 优惠券列表看到赠课券曝光
            click: 'dt_1212_dual12_bogo_give_coupon_id_{couponId}_to_use', // 赠课券点击“去使用
            listBtn: 'dt_1212_dual12_bogo_course_list_btn', // 课程列表页8折按钮   渠道号是100348
            courseBtn: 'dt_1212_dual12_bogo_my_course_btn ' // 我的课8折按钮      渠道号是100347
        },
        // 曝光统计
        sendExposePvuv: function (data, callback) {
            data = data || {}
            data.actChannels = data.channel
            var url = this.data.pvuv
            if (data.actId) {
                url = url.replace('10029', data.actId)
            }
            delete data.channel
            if (!data.expParam) {
                data.expParam = {
                    module: '',
                    tag: ''
                }
            }
            $.get(url, data)
            callback && setTimeout(callback, 300)
        },
        addPvuv: function (data, callback) {
            ApiHelper.myLog('pvuv>>>>', data)
            $.get(data.url || this.data.pvuv.replace('10029', 10033), data)
            callback && setTimeout(callback, 300)
        },
        // 初始化
        init: function () {
            var that = this
            ApiHelper.courseDetails && that.initCourseDetails()
        },
        forbidfShare: function () {
            function onBridgeReady() {
                WeixinJSBridge.invoke('hideOptionMenu');
                wx && typeof wx.hideMenuItems === 'function' && wx.hideOptionMenu()
            }

            if (typeof WeixinJSBridge == "undefined") {
                if (document.addEventListener) {
                    document.addEventListener('WeixinJSBridgeReady', onBridgeReady, false);
                } else if (document.attachEvent) {
                    document.attachEvent('WeixinJSBridgeReady', onBridgeReady);
                    document.attachEvent('onWeixinJSBridgeReady', onBridgeReady);
                }
            } else {
                onBridgeReady();
            }
        },
        // 详情页
        initCourseDetails: function () {
            var that = this
            if (ApiHelper.getQueryString('pfrom') !== 'nospell') {
                return
            }
            that.forbidfShare()
            // 课程详情
            ApiHelper.$on('nospellInfo', function (e, data) {
                if (!data || data.leaveExpireMillis <= 0) {
                    that.showToast('您的免拼券已失效', 3000, function () {
                        location.replace('/wx/groupBuy/courseDetails.html?state='+ ApiHelper.getQueryString('states') +'&courseId=' + ApiHelper.getQueryString('courseId'));
                    })
                    return
                }
                $('body').append($('<span class="nospell-coupon couponLi active" style="display: none;"></span>'))
                $('.nospell-coupon').attr('data-couponid', getQueryString('couponId'))
                $('.course_details').css({
                    paddingTop: '0'
                })
                $('.on_sale_box .symbol').text('超值免拼价').css({
                    color: '#ff6701'
                })
                $('.on_sale_box').css({
                    backgroundImage: 'url("' + that.data.groupPurPath + 'winterVacation/detail_prc_bk.png?v=' + window.jspVersionMoreChange + '")'
                }).show()
                $('.course_details .countDownTest').text('距免拼结束').css({
                    fontSize: '0.36rem'
                })
                $('.course_details .countDown ').css({
                    paddingTop: '0.25rem'
                })
                $('<span class="coupon_time_t"></span>').insertBefore($('.course_details .coupon_time_h'))
                $('#on_sale_money').css({
                    paddingRight: '0.24rem'
                })
                $('.countDown').css({
                    width: '2.9rem'
                })
                new NewTimer(data.leaveExpireMillis, function (changeArr) {
                    $('.course_details .coupon_time_t').css('width', 'auto').text(changeArr[0] + '天')
                    if (parseInt(changeArr[0]) <= 0) {
                        $('.course_details .coupon_time_t').hide()
                    }
                    $('.course_details .coupon_time_h').text(changeArr[1])
                    $('.course_details .coupon_time_m').text(changeArr[2])
                    $('.course_details .coupon_time_s').text(changeArr[3])
                    $('.course_details .coupon_time_ms').text(changeArr[4])
                }, function () {
                    $('.on_sale_box').hide()
                    $('.pay_btn_box').show()
                    $('#payBtnCon').hide()
                }, 100).startCountDown()
                $('#limitPic').hide()
            })
            // 判断是否由邀请页面跳转过来的用户
            if (ApiHelper.getQueryString('prePageName') === 'inviteFriends') {
                return
            }
            $('.pay_btn_box').hide()
            $(payBtnCon).insertBefore($('.pay_btn_box'))
            this.sendExposePvuv({
                actId: 1,
                pvuvKeyId: 785,
                expParam: {
                    module: '',
                    tag: '',
                    courseId: getQueryString('courseId')
                }
            })
            this.sendExposePvuv({
                actId: 1,
                pvuvKeyId: 787
            })
            $('#payBtnCon .home').click(function () {
                var channel = ApiHelper.getQueryString('state') || 100484
                that.sendExposePvuv({
                    actId: 1,
                    pvuvKeyId: 788
                }, function () {
                    location.href = '/app/spa/dengta_h5/nospell?channel=' + channel + '&couponId=' + getQueryString('couponId')
                })
            })
            $('#payBtnCon .ljgm').click(function () {
                that.sendExposePvuv({
                    actId: 1,
                    pvuvKeyId: 786,
                    expParam: {
                        module: '',
                        tag: '',
                        courseId: getQueryString('courseId')
                    }
                })
                $('.sure_pay').click()
            })
        },
        // 是否在可视区域 document.addEventListener('scroll', ApiHelper.throttle(function () {}, 500)
        isInView: function (options) {
            var config = {
                selector: options
            }
            if (typeof options !== 'string') {
                config = options
            }
            var selector = config.selector
            var top = config.top || 0 // 头部距离
            var bottom = config.bottom || 0
            if (!document.querySelector(selector)) {
                return false
            }
            var rect = document.querySelector(selector).getBoundingClientRect()
            var flag = false
            if (top <= 1) {
                top = rect.height * top
            }
            top = -rect.height + top
            if (bottom <= 1) {
                bottom = rect.height * bottom
            }
            bottom = window.innerHeight - bottom - (options.extraBtm || 0)
            if (rect.top <= bottom && rect.top >= top) {
                flag = true
            }
            return flag
        },
        // 是否隐藏
        isHideView: function (options) {
            var config = {
                selector: options
            }
            if (typeof options !== 'string') {
                config = options
            }
            var selector = config.selector
            if (!document.querySelector(selector)) {
                return true
            }
            var minBtm = options.extraBtm || 0
            var maxTop = window.innerHeight - minBtm
            var minTop = options.minTop || 0
            var rect = document.querySelector(selector).getBoundingClientRect()
            var flag = false
            if (rect.top > maxTop || rect.bottom < minTop) {
                flag = true
            }
            return flag
        },
        // 插入未来元素
        checkHas: function (selector, callback) {
            var that = this
            var addBannerCount = 0

            function check() {
                setTimeout(function () {
                    addBannerCount++
                    if ($(selector).length > 0) {
                        callback && callback.call(that)
                    } else {
                        addBannerCount < 5 && check()
                    }
                }, 1000)
            }

            check()
        },
        getStorageSync: function (key) {
            var storage = localStorage.getItem(key)
            try {
                storage = JSON.parse(storage)
            } catch (e) {
                storage = storage
            }
            return storage
        },
        // toast消息
        showToast: function (msg, time, callback) {
            if ($('#toastCon').length === 0) {
                $(toastCon).appendTo($('body'))
            }
            $('#toastCon').css({
                display: 'flex'
            })
            $('#toastCon .msg').text(msg)
            setTimeout(function () {
                $('#toastCon').hide()
                callback && callback()
            }, time || 3000)
        },
        setStorageSync: function (key, data) {
            localStorage.setItem(key, JSON.stringify(data))
        }
    }
</script>

<style scoped lang="less">
    .flex-row {
        /* 混合版本语法: IE 10 */
        display: -webkit-flex;
        /* 新版本语法: Chrome 21+ */
        display: -webkit-box;
        display: -moz-box;
        /* 老版本语法: Firefox (buggy) */
        display: -ms-flexbox;
        display: flex;
    }

    @cl-mask: rgba(0, 0, 0, 0.85);
    /**弹窗**/
    .yidialog-con {
        position: fixed;
        width: 100%;
        height: 100%;
        top: 0px;
        left: 0px;
        display: flex;
        align-items: center;
        justify-content: center;
        z-index: 1000;

        .yid-back {
            position: absolute;
            left: 0px;
            top: 0px;
            width: 100%;
            height: 100%;
            text-align: center;
            background: @cl-mask;
        }

        .yid-con {
            position: relative;
            display: flex;
            justify-content: center;
            align-content: center;
            color: #ffffff;
            flex-wrap: wrap;

            .yid-cls {
                position: relative;
                z-index: 9999;
                width: 0.51rem;
                height: 0.51rem;
                flex-shrink: 0;
            }

            .yid-hand {
                position: absolute;
                width: 1rem;
                top: 3.1rem;
                right: 0.1rem;
                animation: handClick 1s infinite;
            }
        }

        .yid-con-col {
            flex-direction: column;
        }
    }

    /**toast**/
    .yid-toast-con {
        display: none;

        .yid-back {
            opacity: 0;
        }

        .yid-con {
            .yid-con-body {
                justify-content: center;
                align-items: center;

                .msg {
                    padding: 20px;
                    background-color: #333333;
                    color: #ffffff;
                    font-size: 28px;
                    border-radius: 10px;
                }
            }
        }
    }

    /**购买按钮**/
    .pay-btn-con {
        position: fixed;
        bottom: 0;
        left: 0;
        right: 0;
        align-items: center;

        .home, .ljgm {
            width: 240px;
            height: 108px;
            background-color: #ff7637;
            justify-content: center;
            color: #ffffff;
            font-size: 36px;
            align-items: center;
        }

        .ljgm {
            flex-grow: 1;
            background-color: #ff4e00;
        }
    }

    .one-line-dot {
        overflow: hidden;
        text-overflow: ellipsis;
        white-space: nowrap;
        word-break: keep-all;
        max-lines: 1;
    }

    .my-hand-ani {
        animation: myHandAni 1s infinite;
    }

    @keyframes myHandAni {
        50% {
            left: 80px;
        }
        0%, 100% {
            left: 50px;
        }
    }

    @keyframes iconClick {
        0%, 100% {
            margin-bottotm: 0;
        }
        50% {
            margin-bottom: -35px;
            transform: scale(1.1);
        }
    }

    @keyframes handClick {
        from {
            margin-top: 0rem;
            margin-right: 0rem;
        }
        50% {
            margin-top: -0.1rem;
            margin-right: 0.1rem;
            transform: scale(0.9);
        }
        to {
            margin-top: -0rem;
            margin-right: 0rem;
        }
    }

    .scale-size {
        animation: scaleSize 2s infinite;
    }

    @keyframes scaleSize {
        from {
            transform: scale(0.9);
            opacity: 0.9;
        }
        50% {
            transform: scale(1.2);
            opacity: 1;
        }
        to {
            transform: scale(0.9);
            opacity: 0.9;
        }
    }

    .heart-beat {
        animation: heartBeat 1s infinite;
    }

    @keyframes heartBeat {
        0% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        14% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        28% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        42% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        70% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }
    }

    /**淡入*/
    .fade-in {
        animation: fadeIn 1s;
    }

    @keyframes fadeIn {
        from {
            opacity: 0;
        }
        to {
            opacity: 1;
        }
    }
</style>
